#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: gui.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from qt import *
from ttpClient import ttpClient
from chooseItemQt3 import chooseItem
from helpBrowserQt3 import helpWindow
from locale import getdefaultlocale
from ttpChooseGuiQt3 import ttpChooseGui
from hasRelationDialogQt3 import hasRelationDialog
from hasNoRelationDialogQt3 import hasNoRelationDialog
import sys,commands,glob,urllib,re,os,ConfigParser,time,random,pickle
import lrcParser,readConfig,s2t
import chardet



class netThread(QThread):
	
	'''
	This class provide a network function for lrcShow-II, normally it connect to the search engine and analysis if the lrc we needed exists
	'''
	
	def __init__(self,receiver,url,proxy,engine):
		QThread.__init__(self)
		self.url=url
		self.receiver=receiver
		self.proxy=proxy
		self.engine=engine
	
	def run(self):
		if(self.engine=='baidu'):
			netEncoder='gb18030'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				lrc_gb=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				self.postEvent(self.receiver,ev)
			else:
				tmp=unicode(lrc_gb,'gb18030').encode('utf8')
				tmpList=re.findall(r'\http\S*?\.lrc',tmp)
				if(len(tmpList)<>0):
					lrcUrlPre=unicode(tmpList[0],'utf8').encode('gb18030')
					lrcEnd=lrcUrlPre.split('/')[-1]
					lrcHead=re.sub(lrcEnd,'',lrcUrlPre)
					lrcUrl=lrcHead+urllib.quote_plus(lrcEnd)
					ff=urllib.urlopen(lrcUrl,None,self.proxy)
					originalLrc=ff.read()
					ff.close()
					timeOut=False
					if(len(originalLrc)==0 or 'img/logo.gif' in originalLrc):
						originalLrc=None
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					self.postEvent(self.receiver,ev)
				else:
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					self.postEvent(self.receiver,ev)
		elif(self.engine=='sogou'):
			netEncoder='gb18030'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				lrc_gb=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				self.postEvent(self.receiver,ev)
			else:
				tmp=unicode(lrc_gb,'gb18030').encode('utf8')
				tmpList=tmpList=re.findall('href=\"downlrc\.jsp\?tGroupid=.*?\"',tmp)
				if(len(tmpList)<>0):
					lrcUrlPre=re.sub('href="|"','',tmpList[0])
					lrcUrl='http://mp3.sogou.com/'+lrcUrlPre
					ff=urllib.urlopen(lrcUrl,None,self.proxy)
					originalLrc=ff.read()
					ff.close()
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					self.postEvent(self.receiver,ev)
				else:
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					self.postEvent(self.receiver,ev)
		elif(self.engine=='ttPlayer'):
			netEncoder='utf8'
			try:
				file=urllib.urlopen(self.url,None,self.proxy)
				webInfo=file.read()
				file.close()
			except IOError:
				originalLrc=None
				timeOut=True
				self.sleep(1)
				ev=netEvent(originalLrc,timeOut,netEncoder)
				self.postEvent(self.receiver,ev)
			else:
				tmpList=re.findall(r'<lrc.*?</lrc>',webInfo)
				if(len(tmpList)==0):
					originalLrc=None
					timeOut=False
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,netEncoder)
					self.postEvent(self.receiver,ev)
				else:
					lrcList=self.ttplayerParser(tmpList)
					if(len(lrcList)==1):
						url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?dl?Id=%d&Code=%d&uid=01&mac=%012x' %(int(lrcList[0][0]),ttpClient.CodeFunc(int(lrcList[0][0]),(lrcList[0][1]+lrcList[0][2])), random.randint(0,0xFFFFFFFFFFFF))
						ff=urllib.urlopen(url,None,self.proxy)
						originalLrc=ff.read()
						ff.close()
						timeOut=False
						self.sleep(1)
						ev=netEvent(originalLrc,timeOut,netEncoder)
						self.postEvent(self.receiver,ev)
					else:
						#self.sleep(1)
						ev=ttpEvent(lrcList)
						self.postEvent(self.receiver,ev)


	
	def ttplayerParser(self,a):
		b=[]
		for i in a:
			c=re.findall('=\".*?\"',i)
			c=map(lambda x: re.sub('=|\"','',x),c)
			b.append(c)
		return b

class downloadFromTtp(QThread):

	'''
	This class provide a special network function for downloading specific lrc file on ttplayer's search engine
	'''
	
	def __init__(self,receiver,url,proxy):
		QThread.__init__(self)
		self.receiver=receiver
		self.url=url
		self.proxy=proxy
	
	def run(self):
		try:
			file=urllib.urlopen(self.url,None,self.proxy)
		except IOError:
			originalLrc=None
			timeOut=True
			ev=netEvent(originalLrc,timeOut,'utf8')
			self.postEvent(self.receiver,ev)
		else:
			originalLrc=file.read()
			timeOut=False
			if('errmsg' and 'errcode' in originalLrc):
				originalLrc=None
			ev=netEvent(originalLrc,timeOut,'utf8')
			self.postEvent(self.receiver,ev)
			#os.system('dcop amarok playlist popupMessage "%s"' %self.url)
		
		

class myThread(QThread):
	
	'''
	This thread class provides the function to waiting for Amarok's signal, and when lrcShow-II first run, it would to decide the Amarok's status
	'''
	
	def __init__(self,receiver,app):
		QThread.__init__(self)
		self.receiver=receiver
		self.app=app

	def run(self):
		status=commands.getoutput('dcop amarok player status')
		if(status=='2' or status=='0'):#播放中 or 停止
			amarokStatus=None
		else:
			amarokStatus='pause'
		amarokSignal='matchNow'
		ev=myEvent(amarokSignal,amarokStatus)
		self.app.postEvent(self.receiver,ev)
		while True:
			signal=sys.stdin.readline().strip()
			if(signal=='engineStateChange: paused'):
				amarokSignal='engineStateChange'
				amarokStatus='pause'
				ev=myEvent(amarokSignal,amarokStatus)
				self.app.postEvent(self.receiver,ev)
			elif(signal=='engineStateChange: playing'):
				amarokSignal='matchNow'
				amarokStatus=None
				self.sleep(1)#for a xine engine's bug
				ev=myEvent(amarokSignal,amarokStatus)
				self.app.postEvent(self.receiver,ev)
			elif(signal=='engineStateChange: empty'):
				amarokSignal='engineStateChange'
				amarokStatus=None
				ev=myEvent(amarokSignal,amarokStatus)
				self.app.postEvent(self.receiver,ev)
			elif(re.search('configure',signal)):
				os.system('dcop amarok playlist popupMessage "Please configurate the script via GUI\'s menu directly."')

class myEvent(QCustomEvent):
	def __init__(self,amarokSignal,amarokStatus):
		QCustomEvent.__init__(self,QEvent.User+1)
		self.amarokSignal=amarokSignal
		self.amarokStatus=amarokStatus

class netEvent(QCustomEvent):
	def __init__(self,originalLrc,timeOut,netEncoder):
		QCustomEvent.__init__(self,QEvent.User+2)
		self.originalLrc=originalLrc
		self.timeOut=timeOut
		self.netEncoder=netEncoder

class ttpEvent(QCustomEvent):
	def __init__(self,alist):
		QCustomEvent.__init__(self,QEvent.User+3)
		self.alist=alist

class mainBox(QTextBrowser):
	
	'''main GUI'''
	
	def __init__(self,*args):
        	apply(QTextBrowser.__init__,(self,) + args)
		self.setCaption(_(u'lrcShow-II'))
		self.setWordWrap(QTextEdit.NoWrap)
		self.childBox=settingBox(self)
		self.childBox.hide()
		self.childMenu=myMenu(self)
		self.showMode='normal'
		self.WFlags=self.getWFlags()
		p=readConfig.readConfig('lrcShow-II.conf')
		(self.path,self.ifDownload,self.lineNum,bc,fc,hc,self.fontType,self.fontSize,self.proxy,self.encoderToWrite,self.searchEngine)=p.parse()
		if(self.proxy=='no'):
			self.proxy=None
		else:
			self.proxy={'http':self.proxy}
		if(self.ifDownload=='yes'):
			self.childMenu.childMenu2.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'是'),1,1)
			self.childMenu.childMenu2.insertItem(_(u'否'),2,2)
			
		else:
			self.childMenu.childMenu2.insertItem(_(u'是'),1,1)
			self.childMenu.childMenu2.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'否'),2,2)
		self.childMenu.childMenu2.insertItem(_(u'仅当前'),3,3)
		self.childMenu.childMenu2.setItemEnabled(3,False)
		a=bc.split(',')
		b=fc.split(',')
		c=hc.split(',')
		self.backGroundColor=QColor(int(a[0]),int(a[1]),int(a[2]))
		self.foreGroundColor=QColor(int(b[0]),int(b[1]),int(b[2]))
		self.highLightColor=QColor(int(c[0]),int(c[1]),int(c[2]))
		self.setVScrollBarMode(QTextEdit.AlwaysOff)
		self.setHScrollBarMode(QTextEdit.AlwaysOff)
		self.setPaletteBackgroundColor(self.backGroundColor)
		self.setPaletteForegroundColor(self.foreGroundColor)
		pl=self.palette()
		pl.setColor(QColorGroup.Highlight,self.backGroundColor)
		pl.setColor(QColorGroup.HighlightedText,self.highLightColor)
		self.setMinimumHeight(140)
		self.setMinimumWidth(420)
		self.setFont(QFont(self.fontType,self.fontSize))
		self.setIcon(QPixmap('../scripts/lrcShow-II/icon/logo.png'))
		self.mytimer=QTimer()
		self.locale=getdefaultlocale()[1]
		self.path=unicode(self.path,'utf8').encode(self.locale)
		mydb=open('lrcShow-II.db','r')
		u=pickle.Unpickler(mydb)
		self.myData=u.load()
		mydb.close()
		self.connect(self.mytimer,SIGNAL("timeout()"),self.scroll)
		self.connect(self.childBox.seekSlowButton,SIGNAL("clicked()"),self.seekSlow)
		self.connect(self.childBox.seekFastButton,SIGNAL("clicked()"),self.seekFast)
		self.connect(self.childBox.saveButton,SIGNAL("clicked()"),self.saveToFile)
		self.connect(self.childBox.editButton,SIGNAL("clicked()"),self.showEditBox)
		self.connect(self.childBox.transferButton,SIGNAL("clicked()"),self.charaTransfer)
		self.connect(self.childMenu,SIGNAL("activated(int)"),self.itemSelected)
		self.connect(self.childMenu.childMenu1,SIGNAL("activated(int)"),self.colorItemSelected)
		self.connect(self.childMenu.childMenu2,SIGNAL("activated(int)"),self.downloadItemSelected)
		self.connect(self.childMenu.childMenu3,SIGNAL("activated(int)"),self.changeMode)
		self.connect(self.childMenu.childMenu4,SIGNAL("activated(int)"),self.adjustItemSelected)
		self.connect(self.childMenu.childMenu5,SIGNAL("activated(int)"),self.controlAmarok)
		self.connect(self.childMenu.childMenu6,SIGNAL("activated(int)"),self.otherFunctions)
		
	def customEvent(self,ev):
		if(ev.type()==QEvent.User+1):
			self.simbol=ev.amarokSignal#预留
			self.amarokStatus=ev.amarokStatus
			if(self.mytimer.isActive()):
					self.mytimer.stop()
			try:
				self.downloadToLocalThread.terminate()
			except:
				pass
			try:
				self.downloadThread.terminate()
			except:
				pass
			try:
				self.chooseItermDialog1.done(-1)
			except:
				pass
			try:
				self.chooseItermDialog2.done(-1)
			except:
				pass
			try:
				self.relationDialog.done(-1)
			except:
				pass
			if(self.amarokStatus and self.simbol=='engineStateChange'):#$暂停
				self.childMenu.childMenu5.changeItem(1,QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_play.png')),_(u'播放'))
			else:
				self.title=commands.getoutput('dcop amarok player title')
				self.artist=commands.getoutput('dcop amarok player artist')
				self.fileName=None
				self.originalLrc=None
				self.childMenu.childMenu2.setItemEnabled(3,False)
				self.encoder=self.encoderToWrite
				
				if(self.title<>'' or self.artist<>''):#$播放中
					if(self.amarokStatus=='pause'):
						self.childMenu.childMenu5.changeItem(1,QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_play.png')),_(u'播放'))
					else:
						self.childMenu.childMenu5.changeItem(1,QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_pause.png')),_(u'暂停'))
					self.childMenu.childMenu5.setItemEnabled(2,True)
					self.childMenu.childMenu6.setItemEnabled(1,True)
					self.childMenu.setItemEnabled(15,True)
					self.checkData()
				else:#$停止
					self.childMenu.childMenu5.changeItem(1,QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_play.png')),_(u'播放'))
					self.childMenu.childMenu5.setItemEnabled(2,False)
					self.childMenu.childMenu6.setItemEnabled(1,False)
					self.childMenu.setItemEnabled(15,False)
					self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
		elif(ev.type()==QEvent.User+2):
			self.originalLrc=ev.originalLrc
			t=ev.timeOut
			self.netEncoder=ev.netEncoder
			if(self.originalLrc):
				self.initEvent(self.originalLrc,True)
			else:
				if(not t):
					self.showInfo('<p align="center">'+_(u'没有找到匹配的歌词')+'</p>')
				else:
					self.showInfo('<p align="center">'+_(u'网络连接超时')+'</p>')
		if(ev.type()==QEvent.User+3):
			lrcList=ev.alist
			self.chooseItermDialog1=ttpChooseGui(self)
			for j in lrcList:
				self.chooseItermDialog1.listBox.insertItem(j[1].decode('utf8')+' - '+j[2].decode('utf8'),lrcList.index(j))
			self.chooseItermDialog1.listBox.setCurrentItem(0)
			result1=self.chooseItermDialog1.exec_loop()
			if(result1==QDialog.Accepted):
				k=self.chooseItermDialog1.listBox.currentItem()
				url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?dl?Id=%d&Code=%d&uid=01&mac=%012x' %(int(lrcList[k][0]),ttpClient.CodeFunc(int(lrcList[k][0]),(lrcList[k][1]+lrcList[k][2])), random.randint(0,0xFFFFFFFFFFFF))
				self.downloadThreadFromTtp=downloadFromTtp(self,url,self.proxy)
				self.downloadThreadFromTtp.start()
			elif(result1==QDialog.Rejected):
				self.showInfo('<p align="center">'+_(u'没有找到匹配的歌词')+'</p>')
			else:
				pass
				
	
	def showInfo(self,lf):
		self.mainContents=lf
		self.initMainEvent()
		self.childMenu.childMenu6.setItemEnabled(4,False)
		self.childMenu.childMenu6.setItemEnabled(2,False)
		self.childBox.saveButton.setEnabled(False)
		self.childBox.seekSlowButton.setEnabled(False)
		self.childBox.seekFastButton.setEnabled(False)
		self.childBox.transferButton.setEnabled(False)
		self.childMenu.childMenu4.setItemEnabled(1,False)
		self.childMenu.childMenu4.setItemEnabled(2,False)
		self.childMenu.childMenu4.setItemEnabled(3,False)
		self.childMenu.setItemEnabled(7,False)

	def initEvent(self,lf,ask=False):
		self.childMenu.childMenu6.setItemEnabled(4,True)
		self.childMenu.childMenu6.setItemEnabled(2,True)
		self.seekTime=0
		self.totalSeekTime=0
		self.childBox.saveButton.setEnabled(False)
		self.childBox.seekSlowButton.setEnabled(True)
		self.childBox.seekFastButton.setEnabled(True)
		self.childBox.transferButton.setEnabled(True)
		self.childMenu.childMenu4.setItemEnabled(3,False)
		self.childMenu.childMenu4.setItemEnabled(1,True)
		self.childMenu.childMenu4.setItemEnabled(2,True)
		self.childMenu.setItemEnabled(7,True)
		
		self.childMenu.setItemEnabled(12,True)#
		self.childBox.editButton.setEnabled(True)#
		if(self.ifDownload=='yes' and ask):
			try:
				unicode(lf,self.netEncoder).encode(self.encoderToWrite)
			except UnicodeEncodeError:
				QMessageBox.critical(self,_(u'编码错误'),_(u'在将搜索到的歌词（%s）编码为您预设的保存编码（%s）时发生错误，此次下载被忽略！\n这一般是由于搜索到的歌词中含有无法编码的字符造成的。\n如果多次出现本对话框，强烈建议您关闭自动下载功能，另外也可以设置保存编码为gb18030或者utf8以避免这个问题。') %(self.netEncoder,self.encoderToWrite))
			else:
				file=open('%s/%s - %s.lrc' %(self.path,self.artist,self.title),'w')
				file.write(unicode(lf,self.netEncoder).encode(self.encoderToWrite))
				file.close()
				self.originalLrc=None
			
		if(self.ifDownload=='no' and ask):
			self.childMenu.childMenu2.setItemEnabled(3,True)
		if(ask):
			a=unicode(lf,self.netEncoder)
			p=lrcParser.lrc(a)
			self.tag,self.mainContents=p.format()
			self.initMainEvent()
			if(self.simbol=='matchNow' or ask):
				self.goToCurrentPara()
			else:
				self.num=0
				self.paraIndex=(self.lineNum-3)/2
				self.mytimer.start(self.tag[0],True)
		else:
			self.encoder=chardet.detect(lf)['encoding']
			if(self.encoder=='GB2312'):
				self.encoder='gb18030'
			#os.system('dcop amarok playlist popupMessage "%s"' %self.encoder)
			try:
				a=unicode(lf,self.encoder)
			except UnicodeDecodeError:
				self.showInfo('<p align="center">'+_(u'读取本地歌词文件时出现编码错误')+'</p>')
				self.childMenu.setItemEnabled(12,False)
				self.childBox.editButton.setEnabled(False)
			else:
				p=lrcParser.lrc(a)
				self.tag,self.mainContents=p.format()
				self.initMainEvent()
				self.goToCurrentPara()

	def initMainEvent(self):
		if(self.mytimer.isActive()):
				self.mytimer.stop()
		self.killTimers()
		j='<p align="center"><br></p>'*((self.lineNum-1)/2)
		self.lrcFile=j+self.mainContents+j
		self.setText(self.lrcFile)
		self.margin=self.paragraphRect(2).y()-self.paragraphRect(1).y()
		h=self.margin*self.lineNum
		self.hPos=h/2-self.margin
		self.setFixedHeight(h)
		self.center(210,self.hPos)
	
	def goToCurrentPara(self):
		currentTime=int(commands.getoutput('dcop amarok player trackCurrentTimeMs'))
		try:
			p=-1
			while True:
				p+=1
				if(self.tag[p]>=currentTime):
					break
		except:
			self.hPos=self.hPos+self.margin*len(self.tag)
			self.paraIndex=len(self.tag)+(self.lineNum-3)/2
			self.center(210,self.hPos)
			self.setSelection(self.paraIndex,0,self.paraIndex+1,0)
		else:
			self.num=p
			self.paraIndex=p+(self.lineNum-3)/2
			if(self.amarokStatus):
				pass
			else:
				self.mytimer.start(self.tag[p]-currentTime,True)
			try:
				self.hPos=self.hPos+self.margin*self.num
				self.center(210,self.hPos)
				self.setSelection(self.paraIndex,0,self.paraIndex+1,0)
			except:
				pass
	
		
	def changeUrlToGb(self,info,locale):
		address=unicode(info,locale).encode('gb18030')
		return address

	def downLoad(self):
		if(self.searchEngine=='baidu'):
			url1='http://mp3.baidu.com/m?f=ms&tn=baidump3lyric&ct=150994944&lf=2&rn=10&word='
			url3='&lm=-1'
			url2_pre='%s %s' %(self.changeUrlToGb(self.title,self.locale),self.changeUrlToGb(self.artist,self.locale))
			url2=urllib.quote_plus(url2_pre)
			url=url1+url2+url3
			self.showInfo('<p align="center">'+_(u'正在从百度搜索...')+'</p>')
		elif(self.searchEngine=='sogou'):
			url1='http://mp3.sogou.com/gecisearch.so?query='
			url2_pre='%s %s' %(self.changeUrlToGb(self.title,self.locale),self.changeUrlToGb(self.artist,self.locale))
			url2=urllib.quote_plus(url2_pre)
			url=url1+url2
			self.showInfo('<p align="center">'+_(u'正在从搜狐搜索...')+'</p>')
		elif(self.searchEngine=='ttPlayer'):
			url='http://lrcct2.ttplayer.com/dll/lyricsvr.dll?sh?Artist=%s&Title=%s&Flags=0' %(ttpClient.EncodeArtTit(unicode(self.artist,self.locale).replace(u' ','').lower()), ttpClient.EncodeArtTit(unicode(self.title,self.locale).replace(u' ','').lower()))
			self.showInfo('<p align="center">'+_(u'正在从ttPlayer歌词服务器搜索...')+'</p>')
		self.downloadThread=netThread(self,url,self.proxy,self.searchEngine)
		self.downloadThread.start()
	
	def checkData(self):
		data=self.myData.get('%s||%s' %(self.artist,self.title),False)
		if(data<>'FLAG.SKIP_ALL' and data<>'FLAG.SKIP_SEARCHLOCAL' and data<>'FLAG.SKIP_SEARCHENGINE' and data and os.path.exists(data)):
			self.fileName=data
			file=open(self.fileName)
			lf=file.read()
			file.close()
			self.initEvent(lf)
		elif(data<>'FLAG.SKIP_ALL' and data<>'FLAG.SKIP_SEARCHLOCAL' and data<>'FLAG.SKIP_SEARCHENGINE' and data and not os.path.exists(data)):
			del self.myData['%s||%s' %(self.artist,self.title)]
			mydb=open('lrcShow-II.db','w')
			pickler=pickle.Pickler(mydb,True)
			pickler.dump(self.myData)
			mydb.close()
			self.searchLocalLrc()
		elif(data=='FLAG.SKIP_SEARCHLOCAL'):
			self.downLoad()
		elif(data=='FLAG.SKIP_SEARCHENGINE'):
			self.searchLocalLrc(False)
		elif(data=='FLAG.SKIP_ALL'):
			self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
		else:
			self.searchLocalLrc()
			

	def searchLocalLrc(self,flag=True):
		if(self.path<>''):
			k=[]
			for lrcfile in glob.glob(self.path+'/*.lrc'):
				if(self.title.lower() in lrcfile.lower() and self.artist.lower() in lrcfile.lower()):
					k.append(lrcfile)
			if(len(k)==0):
				if(flag==True):
					self.downLoad()
				else:
					self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
			elif(len(k)==1):
				self.fileName=k[0]
				file=open(self.fileName)
				lf=file.read()
				file.close()
				self.initEvent(lf)
			else:
				self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
				self.chooseItermDialog2=chooseItem(self)
				for i in k:
					self.chooseItermDialog2.listBox.insertItem(unicode(i,self.locale),k.index(i))
				self.chooseItermDialog2.listBox.setCurrentItem(0)
				result2=self.chooseItermDialog2.exec_loop()
				if(result2==QDialog.Accepted):
					self.fileName=k[self.chooseItermDialog2.listBox.currentItem()]
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData['%s||%s' %(self.artist,self.title)]=self.fileName
						mydb=open('lrcShow-II.db','w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					file=open(self.fileName)
					lf=file.read()
					file.close()
					self.initEvent(lf)
				elif(result2==QDialog.Rejected):
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData['%s||%s' %(self.artist,self.title)]='FLAG.SKIP_SEARCHLOCAL'
						mydb=open('lrcShow-II.db','w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					if(flag==True):
						self.downLoad()
					else:
						self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
				else:
					pass
		else:
			if(flag==True):
				self.downLoad()
			else:
				self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')

	def scroll(self):
		self.num+=1
		self.paraIndex+=1
		if(self.num<>len(self.tag)):
			t=self.tag[self.num]-self.tag[self.num-1]-self.seekTime
			if(t<600):
				self.hPos=self.hPos+self.margin
				self.center(210,self.hPos)
				if(self.lineNum<>1):
					self.setSelection(self.paraIndex,0,self.paraIndex+1,0)
			else:
				self.terminal=self.hPos
				self.terminal=self.terminal+self.margin/5
				self.center(210,self.terminal)
				self.timerId=self.startTimer(80)
			self.mytimer.start(self.tag[self.num]-self.tag[self.num-1]-self.seekTime,True)
			if(self.seekTime<>0):
				self.seekTime=0
		else:
			self.terminal=self.hPos
			self.terminal=self.terminal+self.margin/5
			self.center(210,self.terminal)
			self.timerId=self.startTimer(80)
	
	def timerEvent(self,ev):
		if(ev.timerId()==self.timerId):
			self.terminal=self.terminal+self.margin/5
			if(self.terminal<self.hPos+self.margin):
				self.center(210,self.terminal)
			else:
				self.hPos=self.hPos+self.margin
				self.center(210,self.hPos)
				self.killTimer(self.timerId)
				if(self.lineNum<>1):
					self.setSelection(self.paraIndex,0,self.paraIndex+1,0)
	
	def seekSlow(self):
		if(self.fileName):
			self.childBox.saveButton.setEnabled(True)
			self.childMenu.childMenu4.setItemEnabled(3,True)
		else:
			pass
		self.seekTime=self.seekTime-200
		self.totalSeekTime=self.totalSeekTime-200
	
	def seekFast(self):
		if(self.fileName):
			self.childBox.saveButton.setEnabled(True)
			self.childMenu.childMenu4.setItemEnabled(3,True)
		else:
			pass
		self.seekTime=self.seekTime+200
		self.totalSeekTime=self.totalSeekTime+200
	
	def saveToFile(self):
		file=open(self.fileName)
		content=unicode(file.read(),self.encoder).encode('utf8')
		file.close()
		offsetList=re.findall('\[offset:.*\]',content)
		if(len(offsetList)<>0):
			offsetOld=int(offsetList[0][8:-1])
			offsetNew=offsetOld+self.totalSeekTime
			offsetLine='[offset:%s]' %str(offsetNew)
			content=re.sub('\[offset:.*\]',offsetLine,content)
		else:
			offsetLine='[offset:%s]\n' %str(self.totalSeekTime)
			content=offsetLine+content
		content=unicode(content,'utf8').encode(self.encoderToWrite)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.childBox.saveButton.setEnabled(False)
		self.childMenu.childMenu4.setItemEnabled(3,False)
		self.totalSeekTime=0
		self.encoder=self.encoderToWrite
	
	def showEditBox(self):
		if(self.fileName):
			self.editBox=editBox(self.fileName,self.encoder)
		else:
			QMessageBox.information(self,_(u'提示'),_(u'没有找到本地歌词文件'))
			self.editBox=editBox(self.path,self.encoder)
		self.editBox.show()
	
	def charaTransfer(self):
		p=s2t.s2t(str(self.text().utf8()))
		content=p.transfer()
		self.clear()
		self.setText(content.decode('utf8'))
		
	def adjustItemSelected(self,ev):
		if(ev==1):
			self.seekSlow()
		elif(ev==2):
			self.seekFast()
		elif(ev==3):
			self.saveToFile()
	
	def otherFunctions(self,ev):
		if(ev==1):
			self.title=commands.getoutput('dcop amarok player title')
			self.artist=commands.getoutput('dcop amarok player artist')
			self.fileName=None
			self.originalLrc=None
			self.childMenu.childMenu2.setItemEnabled(3,False)
			self.downLoad()
		elif(ev==2):
			a=re.sub('<p align="center">','',self.mainContents)
			b=re.sub('</p>|<br>','\n',a)
			b=b.encode('utf8')
			lrc='<lyric title=\\"%s\\" artist=\\"%s\\" page_url=\\"http://mp3.baidu.com\\">%s</lyric>' %(self.title,self.artist,b)
			command='dcop amarok contextbrowser showLyrics "%s"' %lrc
			os.system(command)
			os.system('dcop amarok contextbrowser showLyrics')
		elif(ev==3):
			self.customEvent(myEvent('matchNow',None))
		elif(ev==4):
			self.showInfo('<p align="center">'+_(u'欢迎使用lrcShow-II')+'</p>')
			
			
	
	def controlAmarok(self,ev):
		if(ev==1):
			if((self.artist=='' and self.title=='') or self.amarokStatus=='pause'):
				os.system('dcop amarok player play')
			else:
				os.system('dcop amarok player pause')
		elif(ev==2):
			os.system('dcop amarok player stop')
		elif(ev==3):
			os.system('dcop amarok player prev')
		elif(ev==4):
			os.system('dcop amarok player next')
		
	def colorItemSelected(self,ev):
		if(ev==1):
			rgbColor=QColorDialog.getColor(self.backGroundColor)
			if(rgbColor.isValid()):
				self.backGroundColor=rgbColor
				self.setPaletteBackgroundColor(rgbColor)
				self.palette().setColor(QColorGroup.Highlight,rgbColor)
				rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
				p=ConfigParser.ConfigParser()
				p.read('lrcShow-II.conf')
				p.set('option','backroundcolor',rgbString)
				p.write(open('lrcShow-II.conf', 'w'))
		elif(ev==2):
			rgbColor=QColorDialog.getColor(self.foreGroundColor)
			if(rgbColor.isValid()):
				self.foreGroundColor=rgbColor
				self.setPaletteForegroundColor(rgbColor)
				rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
				p.read('lrcShow-II.conf')
				p.set('option','fontcolor',rgbString)
				p.write(open('lrcShow-II.conf', 'w'))
		elif(ev==3):
			rgbColor=QColorDialog.getColor(self.highLightColor)
			if(rgbColor.isValid()):
				self.highLightColor=rgbColor
				pl=self.palette()
				pl.setColor(QColorGroup.HighlightedText,rgbColor)
				rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
				p=ConfigParser.ConfigParser()
				p.read('lrcShow-II.conf')
				p.set('option','highlightcolor',rgbString)
				p.write(open('lrcShow-II.conf', 'w'))
		elif(ev==4):#返回默认配色
			self.backGroundColor=QColor(57,64,98)
			self.foreGroundColor=QColor(255,255,255)
			self.highLightColor=QColor(180,200,255)
			self.setPaletteBackgroundColor(self.backGroundColor)
			self.setPaletteForegroundColor(self.foreGroundColor)
			pl=self.palette()
			pl.setColor(QColorGroup.Highlight,self.backGroundColor)
			pl.setColor(QColorGroup.HighlightedText,self.highLightColor)
			p=ConfigParser.ConfigParser()
			p.read('lrcShow-II.conf')
			p.set('option','backroundcolor','57,64,98')
			p.set('option','fontcolor','255,255,255')
			p.set('option','highlightcolor','180,200,255')
			p.write(open('lrcShow-II.conf', 'w'))
		
	def itemSelected(self,ev):
		if(ev==5):
			font,ok=QFontDialog.getFont(QFont(self.fontType,self.fontSize),self)
			if ok:
				self.setFont(font)
				self.fontType=font.family()
				self.fontSize=font.pointSize()
				fontFamily=str(font.family().utf8())
				fontSize=str(font.pointSize())
				self.initMainEvent()
				self.goToCurrentPara()
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				l.set('option','fonttype',fontFamily)
				l.set('option','fontsize',fontSize)
				l.write(open('lrcShow-II.conf', 'w'))
		elif(ev==6):
			num,ok=QInputDialog.getInteger(_(u'设置行数'),_(u'请输入1－19的奇数，否则无效'),self.lineNum,1,19,2)
			if(ok and num<>self.lineNum and num in range(1,21,2)):
				self.lineNum=num
				self.initMainEvent()
				self.goToCurrentPara()
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				l.set('option','linenumber',str(num))
				l.write(open('lrcShow-II.conf', 'w'))

		elif(ev==7):
			self.charaTransfer()
		elif(ev==8):
			path=QFileDialog.getExistingDirectory(self.path.decode(self.locale),self)
			path=str(path.utf8())
			if(path==''):
				pass
			else:
				if(path[-1]=='/'):
					path=path[:-1]
				self.path=unicode(path,'utf8').encode(self.locale)
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				l.set('option','lrcpath',path)
				l.write(open('lrcShow-II.conf', 'w'))
				if(not os.access(path,os.W_OK)):
					QMessageBox.warning(self,_(u'注意'),_(u'该目录您不具备写权限，一切相关操作将被忽略！'))

		elif(ev==11):
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			if(self.proxy):
				k,ok=QInputDialog.getText(_(u'代理设置'),_(u'请输入您要使用的Http代理，留空则表示不使用代理\n代理形式如http://www.xxx.yyy.com:80或者http://606.60.60.60:80'),QLineEdit.Normal,self.proxy['http'],self)
			else:
				k,ok=QInputDialog.getText(_(u'代理设置'),_(u'请输入您要使用的Http代理，留空则表示不使用代理\n代理形式如http://www.xxx.yyy.com:80或者http://606.60.60.60:80'),QLineEdit.Normal,QString.null,self)
			if(ok):
				if(str(k.utf8())==''):
					l.set('option','proxy','no')
					l.write(open('lrcShow-II.conf', 'w'))
					self.proxy=None
				else:
					l.set('option','proxy',str(k.utf8()))
					l.write(open('lrcShow-II.conf', 'w'))
					self.proxy={'http':str(k.utf8())}
		elif(ev==12):
			self.showEditBox()
		elif(ev==13):
			l=ConfigParser.ConfigParser()
			l.read('lrcShow-II.conf')
			strList=['baidu','sogou','ttPlayer']
			engineList=QStringList() 
			engineList=engineList.fromStrList(strList)
			index=strList.index(l.get('option','searchengine'))
			engine,ok=QInputDialog.getItem(_(u'设置搜索引擎'),_(u'请选择网络搜索引擎：'),engineList,index,False,self)
			if(ok):
				self.searchEngine=str(engine.utf8())
				l.set('option','searchengine',self.searchEngine)
				l.write(open('lrcShow-II.conf', 'w'))

		elif(ev==15):
			data=self.myData.get('%s||%s' %(self.artist,self.title),False)
			if(data):
				self.relationDialog=hasRelationDialog(self)
				self.relationDialog.trackLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
				if(data=='FLAG.SKIP_SEARCHLOCAL'):
					content=_(u'不搜索本地')
				elif(data=='FLAG.SKIP_SEARCHENGINE'):
					content=_(u'不搜索网络')
				elif(data=='FLAG.SKIP_ALL'):
					content=_(u'什么都不做')
				else:
					content=unicode(data,self.locale)
				self.relationDialog.relationLabel.setText(content)
				result3=self.relationDialog.exec_loop()
				if(result3==1):
					del self.myData['%s||%s' %(self.artist,self.title)]
					mydb=open('lrcShow-II.db','w')
					pickler=pickle.Pickler(mydb,True)
					pickler.dump(self.myData)
					mydb.close()
				else:
					pass	
			else:
				self.relationDialog=hasNoRelationDialog(self)
				self.relationDialog.trackLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
				result3=self.relationDialog.exec_loop()
				if(result3==1):
					if(self.relationDialog.comboBox.currentItem()==1):
						content='FLAG.SKIP_SEARCHLOCAL'
					elif(self.relationDialog.comboBox.currentItem()==2):
						content='FLAG.SKIP_SEARCHENGINE'
					elif(self.relationDialog.comboBox.currentItem()==3):
						content='FLAG.SKIP_ALL'
					self.myData['%s||%s' %(self.artist,self.title)]=content
					mydb=open('lrcShow-II.db','w')
					pickler=pickle.Pickler(mydb,True)
					pickler.dump(self.myData)
					mydb.close()
				else:
					pass
			#os.system('dcop amarok playlist popupMessage "%s"' %result3)
		elif(ev==16):
			a=QMessageBox.question(self,_(u'询问'),_(u'该设置项将影响到下载lrc歌词（包括修改后的保存）时所用到的编码\n是否继续？'),QMessageBox.Yes,QMessageBox.No)
			if(a==3):
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				strList=['latin1','big5','big5-hkscs','eucjp','shift-jis','iso 2022-jp-1','euc-jisx0213','euckr','gb2312','gbk','gb18030','utf8','utf16','koi8-r','koi8-u','iso 8859-1','iso 8859-2','iso 8859-3','iso 8859-4','iso 8859-5','iso 8859-6','iso 8859-7','iso 8859-8','iso 8859-9','iso 8859-10','iso 8859-13','iso 8859-14','iso 8859-15','ibm850','ibm866','cp874','cp1250','cp1251','cp1252','cp1253','cp1254','cp1255','cp1256','cp1257','cp1258','tis-620','mac roman']
				codecList=QStringList() 
				codecList=codecList.fromStrList(strList)
				index=strList.index(l.get('option','encoder'))
				codec,ok=QInputDialog.getItem(_(u'设置保存歌词编码'),_(u'请选择lrc歌词的保存编码：'),codecList,index,False,self)
				if(ok):
					self.encoderToWrite=str(codec.utf8())
					l.set('option','encoder',self.encoderToWrite)
					l.write(open('lrcShow-II.conf', 'w'))
			else:
				pass
		elif(ev==17):
			helpBrowser=helpWindow(self)
			helpBrowser.show()
		elif(ev==18):
			QMessageBox.about(self,_(u'关于lrcShow-II'),_(u'软件版本：lrcShow-II-0.6.1\n软件简介：动态显示lrc歌词的Amarok脚本\n软件作者：三翻领\n授权协议：GPL-v2.0\nBug提交：xujia19@gmail.com'))
		elif(ev==19):
			self.close()

	def downloadItemSelected(self,ev):
		if(ev==1):
			if(self.ifDownload=='yes'):
				pass
			else:
				self.childMenu.childMenu2.clear()
				self.childMenu.childMenu2.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'是'),1,1)
				self.childMenu.childMenu2.insertItem(_(u'否'),2,2)
				self.childMenu.childMenu2.insertItem(_(u'仅当前'),3,3)
				self.childMenu.childMenu2.setItemEnabled(3,False)
				self.ifDownload='yes'
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				l.set('option','download',self.ifDownload)
				l.write(open('lrcShow-II.conf', 'w'))
				if(self.originalLrc):
					try:
						unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite)
					except UnicodeEncodeError:
						QMessageBox.critical(self,_(u'编码错误'),_(u'在将搜索到的歌词（%s）编码为您预设的保存编码（%s）时发生错误，此次下载被忽略！\n这一般是由于搜索到的歌词中含有无法编码的字符造成的。\n如果多次出现本对话框，强烈建议您关闭自动下载功能，另外也可以设置保存编码为gb18030或者utf8以避免这个问题。') %(self.netEncoder,self.encoderToWrite))
					else:
						if(os.path.exists('%s/%s - %s.lrc' %(self.path,self.artist,self.title))):
							a=QMessageBox.question(self,_(u'询问'),_(u'同名文件已存在，是否覆盖？'),QMessageBox.Yes.QMessageBox.No)
							if(a==3):
								file=open('%s/%s - %s.lrc' %(self.path,self.artist,self.title),'w')
								file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
								file.close()
								self.originalLrc=None
								self.fileName='%s/%s - %s.lrc' %(self.path,self.artist,self.title)
								self.encoder=self.encoderToWrite
							else:
								pass
								
						else:
							file=open('%s/%s - %s.lrc' %(self.path,self.artist,self.title),'w')
							file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
							file.close()
							self.originalLrc=None
							self.fileName='%s/%s - %s.lrc' %(self.path,self.artist,self.title)
							self.encoder=self.encoderToWrite
				

		elif(ev==2):
			if(self.ifDownload=='no'):
				pass
			else:
				self.childMenu.childMenu2.clear()
				self.childMenu.childMenu2.insertItem(_(u'是'),1,1)
				self.childMenu.childMenu2.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'否'),2,2)
				self.childMenu.childMenu2.insertItem(_(u'仅当前'),3,3)
				if(self.originalLrc):
					self.childMenu.childMenu2.setItemEnabled(3,True)
				else:
					self.childMenu.childMenu2.setItemEnabled(3,False)
				self.ifDownload='no'
				l=ConfigParser.ConfigParser()
				l.read('lrcShow-II.conf')
				l.set('option','download',self.ifDownload)
				l.write(open('lrcShow-II.conf', 'w'))
		elif(ev==3):
			try:
				unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite)
			except UnicodeEncodeError:
				QMessageBox.critical(self,_(u'编码错误'),_(u'在将搜索到的歌词（%s）编码为您预设的保存编码（%s）时发生错误，此次下载被忽略！\n这一般是由于搜索到的歌词中含有无法编码的字符造成的。\n如果多次出现本对话框，强烈建议您关闭自动下载功能，另外也可以设置保存编码为gb18030或者utf8以避免这个问题。') %(self.netEncoder,self.encoderToWrite))
			else:
				if(os.path.exists('%s/%s - %s.lrc' %(self.path,self.artist,self.title))):
					a=QMessageBox.question(self,_(u'询问'),_(u'同名文件已存在，是否覆盖？'),QMessageBox.Yes,QMessageBox.No)
					if(a==3):
						file=open('%s/%s - %s.lrc' %(self.path,self.artist,self.title),'w')
						file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
						file.close()
						self.originalLrc=None
						self.childMenu.childMenu2.setItemEnabled(3,False)
						self.fileName='%s/%s - %s.lrc' %(self.path,self.artist,self.title)
					else:
						pass
				else:
					file=open('%s/%s - %s.lrc' %(self.path,self.artist,self.title),'w')
					file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
					file.close()
					self.originalLrc=None
					self.childMenu.childMenu2.setItemEnabled(3,False)
					self.fileName='%s/%s - %s.lrc' %(self.path,self.artist,self.title)
	
	def changeMode(self,ev):
		if(ev==1):
			if(self.showMode=='normal'):
				pass
			else:
				self.childMenu.childMenu3.clear()
				self.childMenu.childMenu3.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'普通模式'),1,1)
				self.childMenu.childMenu3.insertItem(_(u'全屏模式'),2,2)
				self.childMenu.childMenu3.insertItem(_(u'OSD模式'),3,3)
				self.childMenu.setItemEnabled(6,True)
				if(self.showMode=='osd'):
					self.reparent(None,self.WFlags,self.pos(),False)
					self.setIcon(QPixmap('../scripts/lrcShow-II/icon/logo.png'))
					self.show()
				elif(self.showMode=='fullscreen'):
					#self.setWindowState(Qt.WindowNoState)
					self.showNormal()
					l=ConfigParser.ConfigParser()
					l.read('lrcShow-II.conf')
					self.lineNum=int(l.get('option','linenumber'))
					self.initMainEvent()
					self.goToCurrentPara()
				self.showMode='normal'
		if(ev==2):
			if(self.showMode=='fullscreen'):
				pass
			else:
				self.childMenu.childMenu3.clear()
				self.childMenu.childMenu3.insertItem(_(u'普通模式'),1,1)
				#self.childMenu.childMenu3.setAccel(QKeySequence(u'Esc'),1)
				self.childMenu.childMenu3.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'全屏模式'),2,2)
				self.childMenu.childMenu3.insertItem(_(u'OSD模式'),3,3)
				self.childMenu.childMenu3.setItemEnabled(3,False)
				self.childMenu.setItemEnabled(6,False)
				#self.setWindowState(Qt.WindowFullScreen)
				self.showFullScreen()
				self.lineNum=QApplication.desktop().height()/self.margin
				self.initMainEvent()
				self.goToCurrentPara()
				self.showMode='fullscreen'
		if(ev==3):#无边框置顶
			if(self.showMode=='osd'):
				pass
			else:
				self.childMenu.childMenu3.clear()
				self.childMenu.childMenu3.insertItem(_(u'普通模式'),1,1)
				#self.childMenu.childMenu3.setAccel(QKeySequence(u'Esc'),1)
				self.childMenu.childMenu3.insertItem(_(u'全屏模式'),2,2)
				self.childMenu.childMenu3.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'OSD模式'),3,3)
				self.childMenu.childMenu3.setItemEnabled(2,False)
				self.reparent(None,Qt.WStyle_Customize+Qt.WStyle_StaysOnTop,self.pos(),False)
				self.setIcon(QPixmap('../scripts/lrcShow-II/icon/logo.png'))
				self.show()
				self.showMode='osd'
	
	def keyPressEvent(self,ev):#设置快捷键
		if(ev.key()==Qt.Key_Minus and self.childMenu.childMenu4.isItemEnabled(1)):
			self.seekSlow()
		elif(ev.key()==Qt.Key_Plus and self.childMenu.childMenu4.isItemEnabled(2)):
			self.seekFast()
		elif(ev.key()==Qt.Key_S and self.childMenu.childMenu4.isItemEnabled(3)):
			self.saveToFile()
		elif(ev.key()==Qt.Key_F and self.showMode=='normal'):
			self.childMenu.childMenu3.emit(SIGNAL("activated(int)"),(2,))
		elif(ev.key()==Qt.Key_Escape and (self.showMode=='fullscreen' or self.showMode=='osd')):
			self.childMenu.childMenu3.emit(SIGNAL("activated(int)"),(1,))
		elif(ev.key()==Qt.Key_O and self.showMode=='normal'):
			self.childMenu.childMenu3.emit(SIGNAL("activated(int)"),(3,))
		elif(ev.key()==Qt.Key_E):
			self.childMenu.emit(SIGNAL("activated(int)"),(12,))

	def contentsWheelEvent(self,ev):
		pass
	
	def contentsMousePressEvent(self,ev):
		self.xPos=ev.x()
		self.yPos=ev.y()
		
	def contentsMouseReleaseEvent(self,ev):
		pass
	
	def contentsMouseDoubleClickEvent(self,ev):#开关菜单
		if(self.childBox.isShown()):
			self.childBox.hide()
		else:
			self.childBox.show()

	def contentsContextMenuEvent(self,ev):
		self.childMenu.popup(ev.globalPos())
	
	def contentsMouseMoveEvent(self,ev):#移动窗口
		if(ev.state()==Qt.LeftButton):
			a=ev.x()-self.xPos
			b=ev.y()-self.yPos
			self.move(self.x()+a,self.y()+b)
		else:
			pass
		

class settingBox(QWidget):
	
	def __init__(self,*args):
        	apply(QWidget.__init__,(self,) + args)
		self.setFixedHeight(20)
		self.setFixedWidth(170)
		color=QColor(150,189,255)
		self.setPaletteBackgroundColor(color)
		
		self.seekSlowButton=QPushButton(self,'seekSlowButton')
		self.seekSlowButton.setGeometry(QRect(0,0,30,20))
		self.seekSlowButton.setPixmap(QPixmap('../scripts/lrcShow-II/icon/backward.png'))
		self.seekSlowButton.setPaletteBackgroundColor(color)
		QToolTip.add(self.seekSlowButton,_(u'歌词整体滞后0.2秒'))
		
		self.seekFastButton=QPushButton(self,'seekFastButton')
		self.seekFastButton.setGeometry(QRect(30,0,30,20))
		self.seekFastButton.setPixmap(QPixmap('../scripts/lrcShow-II/icon/forward.png'))
		self.seekFastButton.setPaletteBackgroundColor(color)
		QToolTip.add(self.seekFastButton,_(u'歌词整体提前0.2秒'))
		
		self.saveButton=QPushButton(self,'saveButton')
		self.saveButton.setGeometry(QRect(60,0,30,20))
		#self.saveButton.setText('保存'.decode('utf8'))
		self.saveButton.setPixmap(QPixmap('../scripts/lrcShow-II/icon/save.png'))
		self.saveButton.setPaletteBackgroundColor(color)
		self.saveButton.setEnabled(False)
		QToolTip.add(self.saveButton,_(u'保存新偏移量至文件'))
		
		self.transferButton=QPushButton(self,'transferButton')
		self.transferButton.setGeometry(QRect(100,0,30,20))
		#self.transferButton.setText(u'简繁')
		self.transferButton.setPixmap(QPixmap('../scripts/lrcShow-II/icon/st.png'))
		self.transferButton.setPaletteBackgroundColor(color)
		QToolTip.add(self.transferButton,_(u'简繁体快速转换'))
		
		self.editButton=QPushButton(self,'editButton')
		self.editButton.setGeometry(QRect(140,0,30,20))
		#self.editButton.setText(u'编辑')
		self.editButton.setPixmap(QPixmap('../scripts/lrcShow-II/icon/edit.png'))
		self.editButton.setPaletteBackgroundColor(color)
		QToolTip.add(self.editButton,_(u'开启lrcShow-II歌词编辑器'))

class editBox(QWidget):
	
	def __init__(self,f,e,*args):
		apply(QWidget.__init__,(self,)+args)
		self.setIcon(QPixmap('../scripts/lrcShow-II/icon/logo.png'))
		self.setCaption(_(u'lrcShow-II歌词编辑器'))
		self.setMinimumSize(QSize(480,280))
		layout = QVBoxLayout(self,2,6,"layout")
		self.menuArea=menuArea(self)
		self.editArea=editArea(self)
		self.editArea.setFocus()
		layout.addWidget(self.menuArea)
		layout.addWidget(self.editArea)
		self.fileName=f
		self.encoder=e
		if(os.path.isfile(self.fileName)):
			self.editArea.showText(self.fileName,self.encoder)
		else:
			self.editArea.setText(_(u'[ti:]\n[ar:]\n[al:]\n[by:]'))
		self.connect(self.menuArea.save,SIGNAL("clicked()"),self.save)
		self.connect(self.menuArea.saveAs,SIGNAL("clicked()"),self.saveAs)
		self.connect(self.editArea,SIGNAL("textChanged()"),self.saveEnabled)
		self.connect(self.menuArea.clearTag,SIGNAL("clicked()"),self.clearTag)
		self.connect(self.menuArea.insertTag,SIGNAL("clicked()"),self.insertTag)
		self.connect(self.menuArea.transferButton,SIGNAL("clicked()"),self.charaTransfer)
	
	def saveEnabled(self):
		if(os.path.isfile(self.fileName)):
			self.menuArea.save.setEnabled(True)
		else:
			pass	
	def save(self):
		content=str(self.editArea.text().utf8())
		content=unicode(content,'utf8').encode(self.encoder)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.menuArea.save.setEnabled(False)
	
	def saveAs(self):
		filename=QFileDialog.getSaveFileName(self.fileName.decode(getdefaultlocale()[1]),'*.txt *.lrc',self,'FileDialog')
		if(str(filename.utf8())<>''):
			content=str(self.editArea.text().utf8())
			content=unicode(content,'utf8').encode(self.encoder)
        		file=open(str(filename.local8Bit()),'w')
        		file.write(content)
        		file.close()
        	else:
        		pass
	
	def charaTransfer(self):
		p=s2t.s2t(str(self.editArea.text().utf8()))
		content=p.transfer()
		self.editArea.clear()
		self.editArea.setText(content.decode('utf8'))
	
	def clearTag(self):
		content=str(self.editArea.text().utf8())
		self.editArea.clear()
		content=re.sub('\[\d\d:\d\d.*?\]','',content)
		self.editArea.setText(content.decode('utf8'))
	
	def insertTag(self):
		currentTime=int(commands.getoutput('dcop amarok player trackCurrentTimeMs'))
		munites,ms=divmod(currentTime,60000)
        	if(len(str(ms))<>5):
                	seconds='0'+str(ms)[0]
        	else:
                	seconds=str(ms)[0:2]
        	mseconds=str(ms)[-3:-1]
        	munites=str(munites)
        	if(len(munites)<>2):
                	munites='0'+munites
        	currentTag='[%s:%s.%s]' %(munites,seconds,mseconds)
		self.editArea.insert(currentTag)
        	self.editArea.moveCursor(QTextEdit.MoveLineStart,0)
        	self.editArea.moveCursor(QTextEdit.MoveDown,0)

class menuArea(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,)+args)
		self.setMinimumHeight(30)
		
		self.save=QPushButton(self,'save')
		self.save.setGeometry(QRect(5,0,70,30))
		self.save.setText(_(u'快速保存'))
		self.save.setEnabled(False)
		
		self.saveAs=QPushButton(self,'saveAs')
		self.saveAs.setGeometry(QRect(80,0,70,30))
		self.saveAs.setText(_(u'另存为...'))
		
		self.transferButton=QPushButton(self,'transferButton')
		self.transferButton.setGeometry(QRect(155,0,70,30))
		self.transferButton.setText(_(u'简繁转换'))
		
		self.clearTag=QPushButton(self,'clearTag')
		self.clearTag.setGeometry(QRect(230,0,120,30))
		self.clearTag.setText(_(u'清空时间标签'))
		
		self.insertTag=QPushButton(self,'insertTag')
		self.insertTag.setGeometry(QRect(355,0,120,30))
		self.insertTag.setText(_(u'插入时间标签(F5)'))
		self.insertTag.setAccel(QKeySequence(u'F5'))

class editArea(QTextEdit):
	
	def __init__(self,*args):
		apply(QTextEdit.__init__,(self,)+args)
	
	def showText(self,f,e):
		file=open(f)
		content=unicode(file.read(),e)
		file.close()
		self.setText(content)

class myMenu(QPopupMenu):
	
	def __init__(self,*args):
		apply(QPopupMenu.__init__,(self,)+args)
		self.childMenu1=colorMenu(self)
		self.childMenu4=lrcAdjustMenu(self)
		self.childMenu2=QPopupMenu(self)
		self.childMenu3=QPopupMenu(self)
		self.childMenu5=amarokControl(self)
		self.childMenu6=otherFunctions(self)
		self.childMenu3.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/apply.png')),_(u'普通模式'),1,1)
		self.childMenu3.insertItem(_(u'全屏模式'),2,2)
		self.childMenu3.insertItem(_(u'OSD模式'),3,3)
		

		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/adjust.png')),_(u'调整偏移量'),self.childMenu4,1,1)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok.png')),_(u'Amarok控制'),self.childMenu5,2,2)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/colors.png')),_(u'设置配色'),self.childMenu1,4,4)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/font.png')),_(u'设置字体...'),5,5)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/line.png')),_(u'设置显示行数...'),6,6)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/st.png')),_(u'简繁体互转'),7,7)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/folder.png')),_(u'设置本地歌词路径...'),8,8)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/download.png')),_(u'是否从网络下载'),self.childMenu2,9,9)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/screen.png')),_(u'设置显示模式'),self.childMenu3,10,10)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/proxy.png')),_(u'设置网络代理...'),11,11)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/edit.png')),_(u'歌词编辑器...'),12,12)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/engine.png')),_(u'设置搜索引擎...'),13,13)
		#self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/search.png')),_(u'从网络搜索'),14,14)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/function.png')),_(u'其他功能'),self.childMenu6,14,14)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/relation.png')),_(u'当前音轨歌词策略...'),15,15)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/locale.png')),_(u'设置保存歌词编码...'),16,16)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/help.png')),_(u'查看帮助...'),17,17)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/logo.png')),_(u'关于lrcShow-II...'),18,18)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/exit.png')),_(u'退出lrcShow-II'),19,19)
		self.setItemEnabled(3,False)
		
class colorMenu(QPopupMenu):
	
	def __init__(self,*args):
		apply(QPopupMenu.__init__,(self,)+args)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/background.png')),_(u'修改背景色...'),1,1)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/fontcolor.png')),_(u'修改字体色...'),2,2)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/highlight.png')),_(u'修改标亮色...'),3,3)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/undo.png')),_(u'返回默认配色'),4,4)

class lrcAdjustMenu(QPopupMenu):
	
	def __init__(self,*args):
		apply(QPopupMenu.__init__,(self,)+args)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/backward.png')),_(u'歌词滞后0.2秒'),1,1)
		#self.setAccel(QKeySequence(u'-'),1)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/forward.png')),_(u'歌词提前0.2秒'),2,2)
		#self.setAccel(QKeySequence(u'+'),2)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/save.png')),_(u'保存偏移量'),3,3)
		#self.setAccel(QKeySequence(u's'),3)

class amarokControl(QPopupMenu):
	
	def __init__(self,*args):
		apply(QPopupMenu.__init__,(self,)+args)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_play.png')),_(u'播放'),1,1)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_stop.png')),_(u'停止'),2,2)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_back.png')),_(u'上一首'),3,3)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/amarok_next.png')),_(u'下一首'),4,4)

class otherFunctions(QPopupMenu):
	
	def __init__(self,*args):
		apply(QPopupMenu.__init__,(self,)+args)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/search.png')),_(u'从网络搜索歌词'),1,1)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/add_lyrics.png')),_(u'传送歌词至Amarok侧边栏'),2,2)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/reload.png')),_(u'重新载入歌词'),3,3)
		self.insertItem(QIconSet(QPixmap('../scripts/lrcShow-II/icon/cancel.png')),_(u'撤销当前歌词'),4,4)
